javax.ws.rs

## Annotation Type FormParam

-     @Target(value={PARAMETER,METHOD,FIELD})
      @Retention(value=RUNTIME)
      @Documented
      public @interface FormParam

  Binds the value(s) of a form parameter contained within a request entity body to a resource method parameter. Values are URL decoded unless this is disabled using the `Encoded` annotation. A default value can be specified using the `DefaultValue` annotation. If the request entity body is absent or is an unsupported media type, the default value is used. The type `T` of the annotated parameter must either:
  1. Be a primitive type
  2. Have a constructor that accepts a single `String` argument
  3. Have a static method named `valueOf` or `fromString` that accepts a single
  4. Have a registered implementation of `ParamConverterProvider` JAX-RS extension SPI that returns a `ParamConverter` instance capable of a "from string" conversion for the type.
  `String` argument (see, for example, `Integer.valueOf(String)`)
- Be `List<T>`, `Set<T>` or `SortedSet<T>`, where `T` satisfies 2, 3 or 4 above. The resulting collection is read-only.

If the type is not one of the collection types listed in 5 above and the form parameter is represented by multiple values then the first value (lexically) of the parameter is used.

Note that, whilst the annotation target permits use on fields and methods, this annotation is only required to be supported on resource method parameters.

Since:
  1.0
Author:
  Paul Sandoz, Marc Hadley
See Also:
  `DefaultValue`, `Encoded`

- - ### Required Element Summary

    Required Elements
    Modifier and Type | Required Element and Description
    --- | ---
    `String` | `value` Defines the name of the form parameter whose value will be used to initialize the value of the annotated method argument.

- - ### Element Detail

    - #### value

          public abstract String value

      Defines the name of the form parameter whose value will be used to initialize the value of the annotated method argument. The name is specified in decoded form, any percent encoded literals within the value will not be decoded and will instead be treated as literal text. E.g. if the parameter name is "a b" then the value of the annotation is "a b", not "a+b" or "a%20b".

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.